$interval:15
$type:0

// 0 - ammo
// 1 - build
// 2 - AC

CreateAmmoBall(){
	u = stack();
	cUid = CreateUnit("CRPLCORE", CurrentCoords());
	AddScriptToUnit(cUid, "redBall.crpl");
	SetScriptVar(cUid, "redBall.crpl", "target", u);
	SetScriptVar(cUid, "redBall.crpl", "maxDistance", maxDistance);
	SetImage(cUid, "main", "none");
}

CreateBuidBall(){
	u = stack();
	cUid = CreateUnit("CRPLCORE", CurrentCoords());
	AddScriptToUnit(cUid, "greenBall.crpl");
	SetScriptVar(cUid, "greenBall.crpl", "target", u);
	SetScriptVar(cUid, "greenBall.crpl", "maxDistance", maxDistance);
	SetImage(cUid, "main", "none");
}

CreateAcBall(){
	u = stack();
	cUid = CreateUnit("CRPLCORE", CurrentCoords());
	AddScriptToUnit(cUid, "acBall.crpl");
	SetScriptVar(cUid, "acBall.crpl", "target", u);
	SetScriptVar(cUid, "acBall.crpl", "maxDistance", maxDistance);
	SetImage(cUid, "main", "none");
}

havePZ(){
	ret=False;
	do(GetAllUnitsInRange(CurrentCoords(), 1, False)){
		tu = stack();
		if(GetUnitType(tu) == "POWERZONE") ret = True;
	}
	ret;
}

main()inline{
	once{
		SetUnitAttribute(Self(), CONST_COUNTSFORVICTORY, false);
		SetUnitAttribute(Self(), CONST_CREATEPZ, false);
		SetUnitAttribute(Self(), CONST_NULLIFIERDAMAGES, false);
		SetUnitAttribute(Self(), CONST_SUPPORTSDIGITALIS, false);
		SetUnitAttribute(Self(), CONST_TAKEMAPSPACE, false);
		
		SetImage(Self(), "main", "none");
		SetImage(Self(), "1", "Custom" $ type);
		SetImage(Self(), "2", "Custom" $ type);
		maxDistance = 10;
		
		SetImagePositionZ(Self(), "1", 1.05);
		SetImagePositionZ(Self(), "2", -100);

		do(GetAllUnitsInRange(CurrentCoords(), 1, False)){
			uid = stack();
			if(uid!=Self()) myUnitUid = uid;
		}
		
		HideTraceLog();

	}
	


	if(havePZ()){
		SetImageScale(Self(), "1", dup(9.5));
		maxDistance = 15.5;
	}else{
		SetImageScale(Self(), "1", dup(6.5));
		maxDistance=10;
	}
	
	if(GetTimer0()==0){
		if(type==0)
			do(GetAllUnitsInRange(CurrentCoords(), maxDistance, False)){
				uid = stack();
				if(	GetUnitType(uid)=="BEAM" ||
					GetUnitType(uid)=="SNIPER" ||
					GetUnitType(uid)=="MORTAR" ||
					GetUnitType(uid)=="BERTHA" ||
					GetUnitType(uid)=="TERP" ||
					GetUnitType(uid)=="SHIELD" ||
					GetUnitType(uid)=="NULLIFIER" ||
					GetUnitType(uid)=="PULSECANNON")
					if(GetUnitAttribute(uid, CONST_ISBUILDING)==False)
					if(GetUnitAttribute(uid, CONST_MAXAMMO)!=0)
						if(GetUnitAttribute(uid, CONST_MAXAMMO)!=GetUnitAttribute(uid, CONST_AMMO))
							CreateAmmoBall(uid);
			}
		else if(type==1)
			do(GetAllUnitsInRange(CurrentCoords(), maxDistance, False)){
				uid = stack();
				if(GetUnitAttribute(uid, CONST_ISBUILDING))
					CreateBuidBall(uid);
			}
		else if(type == 2)
			do(GetAllUnitsInRange(CurrentCoords(), maxDistance, False)){
				uid = stack();
				if(	GetUnitType(uid)=="SPRAYER")
					if(GetUnitAttribute(uid, CONST_ISBUILDING)==False)
						if(GetUnitAttribute(uid, CONST_MAXAMMOAC)!=GetUnitAttribute(uid, CONST_AMMOAC))
							CreateAcBall(uid);
			}
		SetTimer0(interval);
	}

	SetUnitAttribute(Self(), CONST_PIXELCOORDX, GetUnitAttribute(myUnitUid, CONST_PIXELCOORDX));
	SetUnitAttribute(Self(), CONST_PIXELCOORDY, GetUnitAttribute(myUnitUid, CONST_PIXELCOORDY));

}